VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Boleta"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''' <summary>
''' Representa la estructura de una Boleta.
''' </summary>
''' <remarks></remarks>

'Propiedades
Public ListaDetalles As Collection
Public ListaReferencias As Collection
Private dte As EnvioBOL_v11Lib.BOLETADefType
Public Function GetDTE() As EnvioBOL_v11Lib.BOLETADefType
    Set GetDTE = dte
End Function
Public Sub SetDTE(dteTemp As EnvioBOL_v11Lib.BOLETADefType)
    dte = dteTemp
End Sub

Public Function GetValor() As EnvioBOL_v11Lib.documento
    Set GetValor = dte.documento
End Function
Public Sub SetValor(docTemp As EnvioBOL_v11Lib.documento)
    dte.documento = docTemp
End Sub

Public Function GetIdDoc() As EnvioBOL_v11Lib.IdDoc
    Set GetIdDoc = dte.documento.Encabezado.IdDoc
End Function
Public Sub SetIdDoc(idDocTemp As EnvioBOL_v11Lib.IdDoc)
    dte.documento.Encabezado.IdDoc = idDocTemp
End Sub

Public Function GetEmisor() As EnvioBOL_v11Lib.Emisor
    Set GetEmisor = dte.documento.Encabezado.Emisor
End Function
Public Sub SetEmisor(emisorTemp As EnvioBOL_v11Lib.Emisor)
    dte.documento.Encabezado.Emisor = emisorTemp
End Sub

Public Function GetReceptor() As EnvioBOL_v11Lib.Receptor
    Set GetReceptor = dte.documento.Encabezado.Receptor
End Function
Public Sub SetReceptor(receptorTemp As EnvioDTE_v10Lib.Receptor)
    dte.documento.Encabezado.Receptor = receptorTemp
End Sub

Public Function GetTotales() As EnvioBOL_v11Lib.Totales
    Set GetTotales = dte.documento.Encabezado.Totales
End Function
Public Sub SetTotales(totalesTemp As EnvioBOL_v11Lib.Totales)
    dte.documento.Encabezado.Totales = totalesTemp
End Sub


'Constructor
Private Sub Class_Initialize()
    Set ListaDetalles = New Collection
    Set ListaReferencias = New Collection

    Set dte = New EnvioBOL_v11Lib.BOLETADefType
    Set dte.documento = New EnvioBOL_v11Lib.documento
    
End Sub

''' <summary>
''' Establece los valores para Encabezado/IdDoc.
''' </summary>
''' <param name="TipoDTE">Tipo de DTE</param>
''' <param name="Folio">Folio del documento</param>
''' <param name="FchEmis">Fecha de emisin</param>
''' <remarks></remarks>
Public Sub SetEncabezadoIdDoc(ByVal TipoDTE As String, ByRef Folio As Long, ByRef FchEmis As LtXmlComLib12.DateTime)
   Dim IdDoc As EnvioBOL_v11Lib.IdDoc
        Set IdDoc = GetIdDoc()
        IdDoc.Folio.FromLong Folio
        IdDoc.TipoDTE = EnvioBOL_v11Lib.EnumConverter.DTETypeFromString(TipoDTE)
        IdDoc.FchEmis.SetDate FchEmis.Year, FchEmis.Month, FchEmis.Day
End Sub

''' <summary>
''' Establece los valores para Encabezado/Emisor.
''' </summary>
''' <param name="RUTEmisor">RUT del emisor</param>
''' <param name="RznSoc">Razn social del emisor</param>
''' <param name="GiroEmis">Giro del emisor</param>
''' <param name="DirOrigen">Direccin origen del emisor</param>
''' <param name="CmnaOrigen">Comuna origen del emisor</param>
''' <param name="CiudadOrigen">Ciudad origen del emisor</param>
''' <remarks></remarks>
Public Sub SetEncabezadoEmisor(ByVal RUTEmisor As String, ByVal RznSoc As String, ByVal GiroEmis As String, ByVal DirOrigen As String, ByVal CmnaOrigen As String, ByVal CiudadOrigen As String)
    Dim Emisor As EnvioBOL_v11Lib.Emisor
    Set Emisor = GetEmisor()
    Emisor.RUTEmisor = RUTEmisor
    Emisor.RznSocEmisor = RznSoc
    Emisor.GiroEmisor = GiroEmis
    Emisor.DirOrigen = DirOrigen
    Emisor.CmnaOrigen = CmnaOrigen
    Emisor.CiudadOrigen = CiudadOrigen

End Sub

''' <summary>
''' Establece los valores para Encabezado/Receptor.
''' </summary>
''' <param name="RUTRecep">RUT del Receptor</param>
''' <param name="RznSocRecep">Razn social del Receptor</param>
''' <param name="DirRecep">Direccin del Receptor</param>
''' <param name="CmnaRecep">Comuna del Receptor</param>
''' <param name="CiudadRecep">Ciudad del Recepto</param>
''' <remarks></remarks>
Public Sub SetEncabezadoReceptor(ByVal RUTRecep As String, ByVal RznSocRecep As String, ByVal DirRecep As String, ByVal CmnaRecep As String, ByVal CiudadRecep As String)
    Dim Receptor As EnvioBOL_v11Lib.Receptor
        Set Receptor = GetReceptor()
        Receptor.RUTRecep = RUTRecep
        Receptor.RznSocRecep = RznSocRecep
        Receptor.DirRecep = DirRecep
        Receptor.CmnaRecep = CmnaRecep
        Receptor.CiudadRecep = CiudadRecep
End Sub

''' <summary>
''' Establece los valores para Encabezado/Totales.
''' </summary>
''' <param name="MntTotal">Monto total</param>
''' <param name="MntExe">Monto exento</param>
''' <param name="MntNeto">Monto neto</param>
''' <param name="IVA">IVA</param>
''' <remarks></remarks>
Public Sub SetEncabezadoTotales(ByVal MntTotal As Long, ByVal MntExe As Long, ByVal MntNeto As Long, ByVal IVA As String)
     Dim Totales As EnvioBOL_v11Lib.Totales
        Set Totales = GetTotales()
        Totales.MntTotal.FromString MntTotal
        
        Totales.IsValidMntExe = True
        Totales.MntExe.FromBigInteger LtXmlComLib12.Conversions.integerFromString(MntExe, WhitespaceRule_Preserve)
        Totales.IsValidMntNeto = True
        Totales.MntNeto.FromBigInteger LtXmlComLib12.Conversions.integerFromString(MntNeto, WhitespaceRule_Preserve)
        If IVA <> "" And IVA <> 0 Then
            Totales.IsValidIVA = True
            Totales.IVA.FromBigInteger LtXmlComLib12.Conversions.integerFromString(IVA, WhitespaceRule_Preserve)
        End If
End Sub

''' <summary>
''' Adiciona un item a los detalles del documento.
''' </summary>
''' <param name="NmbItem">Nombre del item</param>
''' <param name="MontoItem">Monto del item</param>
''' <param name="IndExe">Indicador exento</param>
''' <param name="DscItem">Descripcin del item</param>
''' <param name="QtyItem">Cantidad del item</param>
''' <param name="UnmdItem">Unidad de medida del item</param>
''' <param name="PrcItem">Precio del item</param>
''' <param name="ListaCdgItem">Lista de cdigos del item</param>
''' <remarks></remarks>
Public Sub AdicionarDetalle(ByVal NmbItem As String, ByVal MontoItem As Long, ByVal IndExe As String, ByVal DscItem As String, ByVal QtyItem As String, ByVal UnmdItem As String, ByVal PrcItem As String, ByRef ListaCdgItem As Collection)
    Dim indice As Integer
    indice = LtXmlComLib12.Conversions.integerFromString("1", WhitespaceRule_Preserve)
    ActualizarDetalleEnIndice NmbItem, MontoItem, IndExe, DscItem, QtyItem, UnmdItem, PrcItem, ListaCdgItem, indice
End Sub

''' <summary>
''' Actualiza un item de los detalles del documento dada la posicin del mismo.
''' </summary>
''' <param name="NmbItem">Nombre del item</param>
''' <param name="MontoItem">Monto del item</param>
''' <param name="IndExe">Indicador exento</param>
''' <param name="DscItem">Descripcin del item</param>
''' <param name="QtyItem">Cantidad del item</param>
''' <param name="UnmdItem">Unidad de medida del item</param>
''' <param name="PrcItem">Precio del item</param>
''' <param name="ListaCdgItem">Lista de cdigos del item</param>
''' <param name="indice">indice del item a actualizar</param>
''' <remarks></remarks>
Public Sub ActualizarDetalleEnIndice(ByVal NmbItem As String, ByVal MontoItem As Long, ByVal IndExe As String, ByVal DscItem As String, ByVal QtyItem As String, ByVal UnmdItem As String, ByVal PrcItem As String, ByRef ListaCdgItem As Collection, ByVal indice As Integer)
    Dim detL As EnvioBOL_v11Lib.Detalle
    Set detL = New EnvioBOL_v11Lib.Detalle
    detL.NroLinDet.FromLong ListaDetalles.Count + 1
    detL.NmbItem = NmbItem
    detL.MontoItem.FromLong MontoItem
    If IndExe <> "" Then
        detL.IndExe = EnvioBOL_v11Lib.EnumConverter.Detalle_IndExeFromString(IndExe)
    End If
    detL.DscItem = DscItem
    
    detL.IsValidQtyItem = True
    detL.QtyItem.FromString QtyItem
    detL.UnmdItem = UnmdItem
    detL.IsValidPrcItem = True
    detL.PrcItem.FromString PrcItem

    detL.CdgItem.Clear
    For Each cdgItemL In ListaCdgItem
        detL.CdgItem.Add (cdgItemL)
    Next

    If indice > 1 Then
        ListaDetalles.Add detL, , indice
        ListaDetalles.Remove (indice + 1)
    Else
        ListaDetalles.Add detL
    End If

End Sub

''' <summary>
''' Elimina un item de la lista de detalles.
''' </summary>
''' <param name="indice">indice del item a eliminar</param>
''' <remarks></remarks>
Public Sub EliminarDetalleEnIndice(ByVal indice As Integer)
    ListaDetalles.Remove indice
End Sub

''' <summary>
''' Crea un objeto CdgItem.
''' </summary>
''' <param name="TpoCodigo">Tipo de cdigo</param>
''' <param name="VlrCodigo">Valor del cdigo</param>
''' <returns>Objeto de tipo CdgItem</returns>
''' <remarks></remarks>
Public Function CrearDetalleCdgItem(ByVal TpoCodigo As String, ByVal VlrCodigo As String) As CdgItem
    Dim cdgItemL As CdgItem
    Set cdgItemL = New EnvioBOL_v11Lib.CdgItem
    cdgItemL.TpoCodigo = TpoCodigo
    cdgItemL.VlrCodigo = VlrCodigo
    Set CrearDetalleCdgItem = cdgItemL
End Function

''' <summary>
''' Adiciona una Referencia a la lista de Referencias.
''' </summary>
''' <param name="CodRef">Cdigo de la Referencia</param>
''' <param name="RazonRef">Razn de la Referencia</param>
''' <remarks></remarks>
Public Sub AdicionarReferencia(ByVal codRef As String, ByVal RazonRef As String)
    Dim Index As Integer
    Index = LtXmlComLib12.Conversions.integerFromString("-1", WhitespaceRule_Preserve)
    ActualizarReferenciaEnIndice codRef, RazonRef, Index
End Sub

''' <summary>
''' Actualiza una Referencia a la lista de Referencias dado el indice de la misma.
''' </summary>
''' <param name="CodRef">Cdigo de la Referencia</param>
''' <param name="RazonRef">Razn de la Referencia</param>
''' <param name="indice">indice de la Referencia en la lista</param>
''' <remarks></remarks>
Public Sub ActualizarReferenciaEnIndice(ByVal codRef As String, ByVal RazonRef As String, ByVal indice As Integer)
    Dim referenciaL As Referencia
    Set referenciaL = New Referencia
    referenciaL.NroLinRef.FromLong ListaReferencias.Count + 1
    referenciaL.codRef = codRef
    If (RazonRef <> Null And RazonRef <> "") Then
        referenciaL.RazonRef = RazonRef
    End If
    
    If indice > 1 Then
        ListaReferencias.Add referenciaL, , indice
        ListaReferencias.Remove (indice + 1)
    Else
        ListaReferencias.Add referenciaL
    End If
End Sub

''' <summary>
''' Elimina una Referencia de la lista de Referencias dado el indice de la misma.
''' </summary>
''' <param name="indice">indice de la Referencia en la lista</param>
''' <remarks></remarks>
Public Sub EliminarReferenciaEnIndice(ByVal indice As Integer)
    ListaReferencias.Remove indice
End Sub

''' <summary>
''' Obtiene el XML representativo de la Boleta.
''' </summary>
''' <returns>string con el XML de la Boleta</returns>
''' <remarks></remarks>
Public Function ObtenerXML() As String
    Dim documento As EnvioBOL_v11Lib.documento
        Set documento = GetValor()
        Dim indice As Long
        indice = 0

        documento.Detalle.Clear
        Dim detL As EnvioBOL_v11Lib.Detalle
        Set detL = New EnvioBOL_v11Lib.Detalle
        For Each detL In ListaDetalles
            indice = indice + 1
            detL.NroLinDet.FromLong indice
            documento.Detalle.Add detL
        Next
        
        indice = 0
        documento.Referencia.Clear
        Dim referenciaL As EnvioBOL_v11Lib.Referencia
        Set referenciaL = New EnvioBOL_v11Lib.Referencia
        For Each referenciaL In ListaReferencias
            indice = indice + 1
            referenciaL.NroLinRef.FromLong indice
            documento.Referencia.Add referenciaL
        Next
        
        Dim helper As GeneradorXmlBoleta
        Set helper = New GeneradorXmlBoleta
        ObtenerXML = helper.ObtenerXML(dte)
End Function



