VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Documento"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
    'Propiedades
    Public ListaDetalles As Collection
    Public ListaReferencias As Collection
    Private dte As EnvioDTE_v10Lib.DTEDefType
    
    Public Function GetDTE() As EnvioDTE_v10Lib.DTEDefType
        Set GetDTE = dte
    End Function
    Public Sub SetDTE(dteTemp As EnvioDTE_v10Lib.DTEDefType)
        dte = dteTemp
    End Sub

    Public Function GetValor() As EnvioDTE_v10Lib.documento
        Set GetValor = dte.DTE_Choice.documento
    End Function
    Public Sub SetValor(docTemp As EnvioDTE_v10Lib.documento)
        dte.DTE_Choice.documento = docTemp
    End Sub

    Public Function GetIdDoc() As EnvioDTE_v10Lib.IdDoc
        Set GetIdDoc = dte.DTE_Choice.documento.Encabezado.IdDoc
    End Function
    Public Sub SetIdDoc(idDocTemp As EnvioDTE_v10Lib.IdDoc)
        dte.DTE_Choice.documento.Encabezado.IdDoc = idDocTemp
    End Sub

    Public Function GetEmisor() As EnvioDTE_v10Lib.Emisor
        Set GetEmisor = dte.DTE_Choice.documento.Encabezado.Emisor
    End Function
    Public Sub SetEmisor(emisorTemp As EnvioDTE_v10Lib.Emisor)
        dte.DTE_Choice.documento.Encabezado.Emisor = emisorTemp
    End Sub

    Public Function GetReceptor() As EnvioDTE_v10Lib.Receptor
        Set GetReceptor = dte.DTE_Choice.documento.Encabezado.Receptor
    End Function
    Public Sub SetReceptor(receptorTemp As EnvioDTE_v10Lib.Receptor)
        dte.DTE_Choice.documento.Encabezado.Receptor = receptorTemp
    End Sub

    Public Function GetTotales() As EnvioDTE_v10Lib.Totales
        Set GetTotales = dte.DTE_Choice.documento.Encabezado.Totales
    End Function
    Public Sub SetTotales(totalesTemp As EnvioDTE_v10Lib.Totales)
        dte.DTE_Choice.documento.Encabezado.Totales = totalesTemp
    End Sub

    'Constructor
    Private Sub Class_Initialize()
        Set ListaDetalles = New Collection
        Set ListaReferencias = New Collection

        Set dte = New EnvioDTE_v10Lib.DTEDefType
        Set dte.DTE_Choice.documento = New EnvioDTE_v10Lib.documento
    End Sub

    ''' <summary>
    ''' Establece los valores para Encabezado/IdDoc.
    ''' </summary>
    ''' <param name="TipoDTE">Tipo de DTE</param>
    ''' <param name="Folio">Folio del documento</param>
    ''' <param name="FchEmis">Fecha de emisin</param>
    ''' <remarks></remarks>
    Public Sub SetEncabezadoIdDoc(ByVal TipoDTE As String, ByRef Folio As Long, ByRef FchEmis As LtXmlComLib12.DateTime)
        Dim IdDoc As EnvioDTE_v10Lib.IdDoc
        Set IdDoc = GetIdDoc()
        IdDoc.Folio.FromLong Folio
        IdDoc.TipoDTE = EnvioDTE_v10Lib.EnumConverter.DTETypeFromString(TipoDTE)
        IdDoc.FchEmis.SetDate FchEmis.Year, FchEmis.Month, FchEmis.Day
    End Sub
    
    ''' <summary>
    ''' Establece los valores para Encabezado/Emisor.
    ''' </summary>
    ''' <param name="RUTEmisor">RUT del emiso</param>
    ''' <param name="RznSoc">Razn social del emisor</param>
    ''' <param name="GiroEmis">Giro del emisor</param>
    ''' <param name="Actectos">Actectos del emisor</param>
    ''' <param name="DirOrigen">Direccin origen del emisor</param>
    ''' <param name="CmnaOrigen">Comuna origen del emisor</param>
    ''' <param name="CiudadOrigen">Ciudad</param>
    ''' <remarks></remarks>
    Public Sub SetEncabezadoEmisor(ByVal RUTEmisor As String, ByVal RznSoc As String, ByVal GiroEmis As String, ByVal Actectos As String, ByVal DirOrigen As String, ByVal CmnaOrigen As String, ByVal CiudadOrigen As String)
        Dim Emisor As EnvioDTE_v10Lib.Emisor
        Set Emisor = GetEmisor()
        Emisor.RUTEmisor = RUTEmisor
        Emisor.RznSoc = RznSoc
        Emisor.GiroEmis = GiroEmis
        Emisor.DirOrigen = DirOrigen

        Emisor.acteco.Clear
        Dim item As Variant
        For Each item In Split(Actectos, ",")
            Emisor.acteco.Add LtXmlComLib12.Conversions.integerFromString(item, WhitespaceRule_Preserve)
        Next
        Emisor.CmnaOrigen = CmnaOrigen
        Emisor.CiudadOrigen = CiudadOrigen

    End Sub

    ''' <summary>
    ''' Establece los valores para Encabezado/Receptor.
    ''' </summary>
    ''' <param name="RUTRecep">RUT del Receptor</param>
    ''' <param name="RznSocRecep">Razn social del Receptor</param>
    ''' <param name="GiroRecep">Giro del Receptor</param>
    ''' <param name="DirRecep">Direccin del Receptor</param>
    ''' <param name="CmnaRecep">Comuna del Receptor</param>
    ''' <param name="CiudadRecep">Ciudad del Receptor</param>
    ''' <remarks></remarks>
    Public Sub SetEncabezadoReceptor(ByVal RUTRecep As String, ByVal RznSocRecep As String, ByVal giroRecep As String, ByVal DirRecep As String, ByVal CmnaRecep As String, ByVal CiudadRecep As String)
        Dim Receptor As EnvioDTE_v10Lib.Receptor
        Set Receptor = GetReceptor()
        Receptor.RUTRecep = RUTRecep
        Receptor.RznSocRecep = RznSocRecep
        Receptor.giroRecep = giroRecep
        Receptor.DirRecep = DirRecep
        Receptor.CmnaRecep = CmnaRecep
        Receptor.CiudadRecep = CiudadRecep
    End Sub

    ''' <summary>
    ''' Establece los valores para Encabezado/Totales.
    ''' </summary>
    ''' <param name="MntTotal">Monto total</param>
    ''' <param name="MntExe">Monto exento</param>
    ''' <param name="MntNeto">Monto neto</param>
    ''' <param name="IVA">IVA</param>
    ''' <remarks></remarks>
    Public Sub SetEncabezadoTotales(ByVal MntTotal As String, ByVal MntExe As String, ByVal MntNeto As String, ByVal IVA As String)
        Dim Totales As EnvioDTE_v10Lib.Totales
        Set Totales = GetTotales()
        Totales.MntTotal.FromString MntTotal
        
        Totales.IsValidMntExe = True
        Totales.MntExe.FromBigInteger LtXmlComLib12.Conversions.integerFromString(MntExe, WhitespaceRule_Preserve)
        Totales.IsValidMntNeto = True
        Totales.MntNeto.FromBigInteger LtXmlComLib12.Conversions.integerFromString(MntNeto, WhitespaceRule_Preserve)
        If IVA <> "" And IVA <> "0" Then
            Totales.IsValidIVA = True
            Totales.IVA.FromBigInteger LtXmlComLib12.Conversions.integerFromString(IVA, WhitespaceRule_Preserve)
        End If
    End Sub

    ''' <summary>
    ''' Adiciona un item a los detalles del documento.
    ''' </summary>
    ''' <param name="NmbItem">Nombre del item</param>
    ''' <param name="MontoItem">Monto del item</param>
    ''' <param name="IndExe">Indicador exento</param>
    ''' <param name="DscItem">Descripcin del item</param>
    ''' <param name="QtyItem">Cantidad del item</param>
    ''' <param name="UnmdItem">Unidad de medida del item</param>
    ''' <param name="PrcItem">Precio del item</param>
    ''' <param name="ListaCdgItem">Lista de cdigos del item</param>
    ''' <remarks></remarks>
    Public Sub AdicionarDetalle(ByVal NmbItem As String, ByVal MontoItem As Long, ByVal IndExe As String, ByVal DscItem As String, ByVal QtyItem As String, ByVal UnmdItem As String, ByVal PrcItem As String, ByRef ListaCdgItem As Collection)
        ActualizarDetalleEnIndice NmbItem, MontoItem, IndExe, DscItem, QtyItem, UnmdItem, PrcItem, ListaCdgItem, -1
    End Sub

    ''' <summary>
    ''' Actualiza un item de los detalles del documento dada la posicin del mismo.
    ''' </summary>
    ''' <param name="NmbItem">Nombre del item</param>
    ''' <param name="MontoItem">Monto del item</param>
    ''' <param name="IndExe">Indicador exento</param>
    ''' <param name="DscItem">Descripcin del item</param>
    ''' <param name="QtyItem">Cantidad del item</param>
    ''' <param name="UnmdItem">Unidad de medida del item</param>
    ''' <param name="PrcItem">Precio del item</param>
    ''' <param name="ListaCdgItem">Lista de cdigos del item</param>
    ''' <param name="indice">indice del item a actualizar</param>
    ''' <remarks></remarks>
    Public Sub ActualizarDetalleEnIndice(ByVal NmbItem As String, ByVal MontoItem As Long, ByVal IndExe As String, ByVal DscItem As String, ByVal QtyItem As String, ByVal UnmdItem As String, ByVal PrcItem As String, ByRef ListaCdgItem As Collection, ByVal indice As Integer)
        Dim detL As EnvioDTE_v10Lib.Detalle
        Set detL = New EnvioDTE_v10Lib.Detalle
        detL.NroLinDet.FromLong ListaDetalles.Count + 1
        detL.NmbItem = NmbItem
        detL.MontoItem.FromLong MontoItem
        If IndExe <> "" Then
            detL.IndExe = EnvioDTE_v10Lib.EnumConverter.Detalle_IndExeFromString(IndExe)
        End If
        detL.DscItem = DscItem
        
        detL.IsValidQtyItem = True
        detL.QtyItem.FromString QtyItem
        detL.UnmdItem = UnmdItem
        detL.IsValidPrcItem = True
        detL.PrcItem.FromString PrcItem

        detL.CdgItem.Clear
        For Each cdgItemL In ListaCdgItem
            detL.CdgItem.Add (cdgItemL)
        Next

        If indice > 1 Then
            ListaDetalles.Add detL, , indice
            ListaDetalles.Remove (indice + 1)
        Else
            ListaDetalles.Add detL
        End If

    End Sub

    ''' <summary>
    ''' Elimina un item de la lista de detalles.
    ''' </summary>
    ''' <param name="indice">indice del item a eliminar</param>
    ''' <remarks></remarks>
    Public Sub EliminarDetalleEnIndice(ByVal indice As Integer)
        ListaDetalles.Remove indice
    End Sub

    ''' <summary>
    ''' Crea un objeto CdgItem.
    ''' </summary>
    ''' <param name="TpoCodigo">Tipo de cdigo</param>
    ''' <param name="VlrCodigo">Valor del cdigo</param>
    ''' <returns>Objeto de tipo CdgItem</returns>
    ''' <remarks></remarks>
    Public Function CrearDetalleCdgItem(ByVal TpoCodigo As String, ByVal VlrCodigo As String) As EnvioDTE_v10Lib.CdgItem
        Dim cdgItemL As EnvioDTE_v10Lib.CdgItem
        Set cdgItemL = New EnvioDTE_v10Lib.CdgItem
        cdgItemL.TpoCodigo = TpoCodigo
        cdgItemL.VlrCodigo = VlrCodigo
        Set CrearDetalleCdgItem = cdgItemL
    End Function

    ''' <summary>
    ''' Adiciona una Referencia a la lista de Referencias.
    ''' </summary>
    ''' <param name="TpoDocRef">Tipo de documento de la Referencia</param>
    ''' <param name="FolioRef">Folio de la Referencia</param>
    ''' <param name="FchRef">Fecha de la Referencia</param>
    ''' <param name="RazonRef">Razn de la Referencia</param>
    ''' <remarks></remarks>
    Public Sub AdicionarReferencia(ByVal tpoDocRef As String, ByVal folioRef As String, ByVal fchRef As LtXmlComLib12.DateTime, ByVal RazonRef As String)
        ActualizarReferenciaEnIndice tpoDocRef, folioRef, fchRef, RazonRef, -1
    End Sub

    ''' <summary>
    ''' Actualiza una Referencia a la lista de Referencias dado el indice de la misma.
    ''' </summary>
    ''' <param name="TpoDocRef">Tipo de documento de la Referencia</param>
    ''' <param name="FolioRef">Folio de la Referencia</param>
    ''' <param name="FchRef">Fecha de la Referencia</param>
    ''' <param name="RazonRef">Razn de la Referencia</param>
    ''' <param name="indice">ndice de la referencia</param>
    ''' <remarks></remarks>
    Public Sub ActualizarReferenciaEnIndice(ByVal tpoDocRef As String, ByVal folioRef As String, ByVal fchRef As LtXmlComLib12.DateTime, ByVal RazonRef As String, ByVal indice As Integer)
        Dim referenciaL As EnvioDTE_v10Lib.Referencia
        Set referenciaL = New EnvioDTE_v10Lib.Referencia
        referenciaL.NroLinRef.FromLong ListaReferencias.Count + 1
        referenciaL.tpoDocRef = tpoDocRef
        referenciaL.folioRef = folioRef
        Set referenciaL.fchRef = fchRef
        If (RazonRef <> "") Then
            referenciaL.RazonRef = RazonRef
        End If

        If indice > -1 Then
            ListaReferencias.Add referenciaL, , indice
            ListaReferencias.Remove (indice + 1)
        Else
            ListaReferencias.Add referenciaL
        End If
    End Sub

    ''' <summary>
    ''' Elimina una Referencia de la lista de Referencias dado el indice de la misma.
    ''' </summary>
    ''' <param name="indice">indice de la Referencia en la lista</param>
    ''' <remarks></remarks>
    Public Sub EliminarReferenciaEnIndice(ByVal indice As Integer)
        ListaReferencias.Remove indice
    End Sub
    
    ''' <summary>
    ''' Obtiene el XML representativo del Documento.
    ''' </summary>
    ''' <returns>string con el XML del Documento</returns>
    ''' <remarks></remarks>
    Public Function ObtenerXML() As String
        Dim documento As EnvioDTE_v10Lib.documento
        Set documento = GetValor()
        Dim indice As Long
        indice = 0

        documento.Detalle.Clear
        Dim detL As EnvioDTE_v10Lib.Detalle
        Set detL = New EnvioDTE_v10Lib.Detalle
        For Each detL In ListaDetalles
            indice = indice + 1
            detL.NroLinDet.FromLong indice
            documento.Detalle.Add detL
        Next
        
        indice = 0
        documento.Referencia.Clear
        Dim referenciaL As EnvioDTE_v10Lib.Referencia
        Set referenciaL = New EnvioDTE_v10Lib.Referencia
        For Each referenciaL In ListaReferencias
            indice = indice + 1
            referenciaL.NroLinRef.FromLong indice
            documento.Referencia.Add referenciaL
        Next
        
        Dim helper As GeneradorXmlDTE
        Set helper = New GeneradorXmlDTE
        ObtenerXML = helper.ObtenerXML(dte)
    End Function
    
    


