VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GeneradorXmlDTE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public Function ObtenerXML(ByRef dte As EnvioDTE_v10Lib.DTEDefType) As String
    dte.Version.FromLong 1
    
    Dim cntx As XmlSerializationContext
    Set cntx = New XmlSerializationContext
    cntx.NamespaceAliases.Add "http://www.sii.cl/SiiDte", "ABCXYZ"
    
    Dim bytes() As Byte
    
    If Not dte.DTE_Choice.documento Is Nothing Then
        LlenarTEDDocumento dte.DTE_Choice.documento
        bytes = dte.DTE_Choice.documento.ToXmlStream(True, XmlFormatting_Indented, XmlEncoding_UTF8, EOLType_CRLF, cntx)
    ElseIf Not dte.DTE_Choice.Exportaciones Is Nothing Then
        LlenarTEDExportaciones dte.DTE_Choice.Exportaciones
        bytes = dte.DTE_Choice.Exportaciones.ToXmlStream(True, XmlFormatting_Indented, XmlEncoding_UTF8, EOLType_CRLF, cntx)
    ElseIf Not dte.DTE_Choice.Liquidacion Is Nothing Then
        LlenarTEDLiquidacion dte.DTE_Choice.Liquidacion
        bytes = dte.DTE_Choice.Liquidacion.ToXmlStream(True, XmlFormatting_Indented, XmlEncoding_UTF8, EOLType_CRLF, cntx)
    End If
    
    Dim xml  As String
    xml = ISOBytesToString(bytes)
    xml = CleanXml(xml)
    xml = Replace(xml, "DTEDefType", "DTE")
    ObtenerXML = xml
End Function

Private Sub LlenarTEDDocumento(ByRef doc As EnvioDTE_v10Lib.documento)
    doc.ID = "ID_1"
    ' TED
    doc.TED.Version = "1.0"
    doc.ID = "ID_1"
    doc.TED.DD.RE = doc.Encabezado.Emisor.RUTEmisor
    doc.TED.DD.TD = doc.Encabezado.IdDoc.TipoDTE
    doc.TED.DD.F.FromBigInteger doc.Encabezado.IdDoc.Folio
    doc.TED.DD.FE.SetFromDateTime CDate(doc.Encabezado.IdDoc.FchEmis.ToString)
    doc.TED.DD.RR = doc.Encabezado.Receptor.RUTRecep
    doc.TED.DD.RSR = "RSR"
    doc.TED.DD.mnt = 0
    doc.TED.DD.IT1 = "IT1"
    'CAF Fake
    doc.TED.DD.CAF.Version = "1.0"
    doc.TED.DD.CAF.DA.RE = "00000000-K"
    doc.TED.DD.CAF.DA.RS = "A"
    doc.TED.DD.CAF.DA.TD = DTEType_33
    doc.TED.DD.CAF.DA.RNG.D.FromString "1"
    doc.TED.DD.CAF.DA.RNG.H.FromString "1"
    doc.TED.DD.CAF.DA.FA.SetDate 2010, 1, 1
    Set doc.TED.DD.CAF.DA.DA_Choice.RSAPK = New EnvioDTE_v10Lib.RSAPK
    doc.TED.DD.CAF.DA.DA_Choice.RSAPK.M.SetBufferFromBase64String "=="
    doc.TED.DD.CAF.DA.DA_Choice.RSAPK.E.SetBufferFromBase64String "=="
    doc.TED.DD.CAF.DA.IDK = 0
    doc.TED.DD.CAF.FRMA.Algoritmo = "SHA1withRSA"
    doc.TED.DD.CAF.FRMA.PrimitiveValue.SetBufferFromBase64String "=="
    doc.TED.DD.TSTED.SetDateTime 2010, 1, 1, 0, 0, 0
    doc.TED.FRMT.Algoritmo = FRMT_Algoritmo_SHA1withRSA
    doc.TED.FRMT.PrimitiveValue.SetBufferFromBase64String "=="
    doc.TmstFirma.SetDateTime 2010, 1, 1, 0, 0, 0

End Sub

Private Sub LlenarTEDExportaciones(ByRef doc As EnvioDTE_v10Lib.Exportaciones)
    doc.TED.Version = "1.0"
    doc.ID = "ID_1"
    doc.TED.DD.RE = doc.Encabezado.Emisor.RUTEmisor
    doc.TED.DD.TD = doc.Encabezado.IdDoc.TipoDTE
    doc.TED.DD.F.FromBigInteger doc.Encabezado.IdDoc.Folio
    doc.TED.DD.FE.SetFromDateTime CDate(doc.Encabezado.IdDoc.FchEmis.ToString)
    doc.TED.DD.RR = doc.Encabezado.Receptor.RUTRecep
    doc.TED.DD.RSR = doc.Encabezado.Receptor.RznSocRecep
    doc.TED.DD.mnt.FromDecimal doc.Encabezado.Totales.MntTotal
    doc.TED.DD.IT1 = "IT1"
    'CAF Fake
    doc.TED.DD.CAF.Version = "1.0"
    doc.TED.DD.CAF.DA.RE = "00000000-K"
    doc.TED.DD.CAF.DA.RS = "A"
    doc.TED.DD.CAF.DA.TD = EXPType_110
    doc.TED.DD.CAF.DA.RNG.D.FromString "1"
    doc.TED.DD.CAF.DA.RNG.H.FromString "1"
    doc.TED.DD.CAF.DA.FA.SetDate 2010, 1, 1
    Set doc.TED.DD.CAF.DA.DA1_Choice.RSAPK = New EnvioDTE_v10Lib.RSAPKB
    doc.TED.DD.CAF.DA.DA1_Choice.RSAPK.M.SetBufferFromBase64String "=="
    doc.TED.DD.CAF.DA.DA1_Choice.RSAPK.E.SetBufferFromBase64String "=="
    doc.TED.DD.CAF.DA.IDK = 0
    doc.TED.DD.CAF.FRMA.Algoritmo = "SHA1withRSA"
    doc.TED.DD.CAF.FRMA.PrimitiveValue.SetBufferFromBase64String "=="
    doc.TED.DD.TSTED.SetDateTime 2010, 1, 1, 0, 0, 0
    doc.TED.FRMT.Algoritmo = FRMT_Algoritmo_SHA1withRSA
    doc.TED.FRMT.PrimitiveValue.SetBufferFromBase64String "=="
    doc.TmstFirma.SetDateTime 2010, 1, 1, 0, 0, 0
End Sub

Private Sub LlenarTEDLiquidacion(ByRef doc As EnvioDTE_v10Lib.Liquidacion)
    doc.TED.Version = "1.0"
    doc.ID = "ID_1"
    doc.TED.DD.RE = doc.Encabezado.Emisor.RUTEmisor
    doc.TED.DD.TD = doc.Encabezado.IdDoc.TipoDTE
    doc.TED.DD.F.FromBigInteger doc.Encabezado.IdDoc.Folio
    doc.TED.DD.FE.SetFromDateTime CDate(doc.Encabezado.IdDoc.FchEmis.ToString)
    doc.TED.DD.RR = doc.Encabezado.Receptor.RUTRecep
    doc.TED.DD.RSR = doc.Encabezado.Receptor.RznSocRecep
    doc.TED.DD.mnt = 0
    doc.TED.DD.IT1 = "IT1"
    'CAF Fake
    doc.TED.DD.CAF.Version = "1.0"
    doc.TED.DD.CAF.DA.RE = "00000000-K"
    doc.TED.DD.CAF.DA.RS = "A"
    doc.TED.DD.CAF.DA.TD = LIQType_43
    doc.TED.DD.CAF.DA.RNG.D.FromString "1"
    doc.TED.DD.CAF.DA.RNG.H.FromString "1"
    doc.TED.DD.CAF.DA.FA.SetDate 2010, 1, 1
    Set doc.TED.DD.CAF.DA.DA0_Choice.RSAPK = New EnvioDTE_v10Lib.RSAPKA
    doc.TED.DD.CAF.DA.DA0_Choice.RSAPK.M.SetBufferFromBase64String "=="
    doc.TED.DD.CAF.DA.DA0_Choice.RSAPK.E.SetBufferFromBase64String "=="
    doc.TED.DD.CAF.DA.IDK = 0
    doc.TED.DD.CAF.FRMA.Algoritmo = "SHA1withRSA"
    doc.TED.DD.CAF.FRMA.PrimitiveValue.SetBufferFromBase64String "=="
    doc.TED.DD.TSTED.SetDateTime 2010, 1, 1, 0, 0, 0
    doc.TED.FRMT.Algoritmo = FRMT_Algoritmo_SHA1withRSA
    doc.TED.FRMT.PrimitiveValue.SetBufferFromBase64String "=="
    doc.TmstFirma.SetDateTime 2010, 1, 1, 0, 0, 0
End Sub

Private Function ISOBytesToString(ByRef Data() As Byte) As String
    ISOBytesToString = BytesToString(Data, "ISO-8859-1")
End Function

Private Function CleanXml(xml As String) As String

    Dim modifiedXml As String
    
    modifiedXml = Replace(xml, "ABCXYZ:", "")
    modifiedXml = Replace(modifiedXml, ":ABCXYZ", "")
    modifiedXml = Replace(modifiedXml, "xmlns=""http://www.sii.cl/SiiDte"" ", "")
    modifiedXml = Replace(modifiedXml, "<!--Created by Liquid XML Data Binding Libraries (www.liquid-technologies.com) for SOUTH CONSULTING SIGNATURE S.A. (1 * Developer Edition)-->" + vbCrLf, "")
    
    CleanXml = modifiedXml

End Function

Private Function BytesToString(ByRef Data() As Byte, ByVal charset As String) As String

    Dim objStream As ADODB.Stream
    Dim strTmp As String
    
    ' init stream
    Set objStream = New ADODB.Stream
    objStream.charset = charset
    objStream.Mode = adModeReadWrite
    objStream.Type = adTypeBinary
    objStream.Open
    
    ' write bytes into stream
    objStream.Write Data
    objStream.Flush
    
    ' rewind stream and read text
    objStream.Position = 0
    objStream.Type = adTypeText
    strTmp = objStream.ReadText
    
    ' close up and return
    objStream.Close
    BytesToString = strTmp

End Function
